Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_acc.c	(revision 1266)
@@ -38,5 +38,5 @@
 PJ_DEF(pj_bool_t) pjsua_acc_is_valid(pjsua_acc_id acc_id)
 {
-    return acc_id>=0 && acc_id<PJ_ARRAY_SIZE(pjsua_var.acc) &&
+    return acc_id>=0 && acc_id<(int)PJ_ARRAY_SIZE(pjsua_var.acc) &&
 	   pjsua_var.acc[acc_id].valid;
 }
@@ -186,5 +186,6 @@
 	pj_strdup_with_null(pjsua_var.pool, &tmp, 
 			    &pjsua_var.ua_cfg.outbound_proxy[i]);
-	r = pjsip_parse_hdr(pjsua_var.pool, &hname, tmp.ptr, tmp.slen, NULL);
+	r = (pjsip_route_hdr*)
+	    pjsip_parse_hdr(pjsua_var.pool, &hname, tmp.ptr, tmp.slen, NULL);
 	if (r == NULL) {
 	    pjsua_perror(THIS_FILE, "Invalid outbound proxy URI",
@@ -201,5 +202,6 @@
 
 	pj_strdup_with_null(pjsua_var.pool, &tmp, &acc_cfg->proxy[i]);
-	r = pjsip_parse_hdr(pjsua_var.pool, &hname, tmp.ptr, tmp.slen, NULL);
+	r = (pjsip_route_hdr*)
+	    pjsip_parse_hdr(pjsua_var.pool, &hname, tmp.ptr, tmp.slen, NULL);
 	if (r == NULL) {
 	    pjsua_perror(THIS_FILE, "Invalid URI in account route set",
@@ -323,5 +325,6 @@
 
     /* ID must be valid */
-    PJ_ASSERT_RETURN(tid>=0 && tid<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+    PJ_ASSERT_RETURN(tid>=0 && tid<(int)PJ_ARRAY_SIZE(pjsua_var.tpdata), 
+		     PJ_EINVAL);
 
     /* Transport must be valid */
@@ -434,5 +437,5 @@
 {
 
-    pjsua_acc *acc = param->token;
+    pjsua_acc *acc = (pjsua_acc*) param->token;
 
     PJSUA_LOCK();
@@ -817,5 +820,5 @@
     }
 
-    sip_uri = pjsip_uri_get_uri(uri);
+    sip_uri = (pjsip_sip_uri*) pjsip_uri_get_uri(uri);
 
     /* Find matching domain AND port */
@@ -955,5 +958,6 @@
     r = acc->route_set.next;
     while (r != &acc->route_set) {
-	pjsip_msg_add_hdr(tdata->msg, pjsip_hdr_clone(tdata->pool, r));
+	pjsip_msg_add_hdr(tdata->msg, 
+			  (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, r));
 	r = r->next;
     }
@@ -1037,5 +1041,5 @@
 
     /* Create the contact header */
-    contact->ptr = pj_pool_alloc(pool, PJSIP_MAX_URL_SIZE);
+    contact->ptr = (char*)pj_pool_alloc(pool, PJSIP_MAX_URL_SIZE);
     contact->slen = pj_ansi_snprintf(contact->ptr, PJSIP_MAX_URL_SIZE,
 				     "%.*s%s<%s:%.*s%s%.*s:%d;transport=%s>",
@@ -1098,8 +1102,9 @@
 
 	/* Otherwise URI is Contact URI */
-	h_contact = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT,
+	h_contact = (pjsip_contact_hdr*)
+		    pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT,
 				       NULL);
 	if (h_contact)
-	    uri = pjsip_uri_get_uri(h_contact->uri);
+	    uri = (pjsip_uri*) pjsip_uri_get_uri(h_contact->uri);
 	
 
@@ -1108,5 +1113,5 @@
 	 */
 	if (uri == NULL)
-	    uri = pjsip_uri_get_uri(rdata->msg_info.from->uri);
+	    uri = (pjsip_uri*) pjsip_uri_get_uri(rdata->msg_info.from->uri);
 
 
@@ -1143,5 +1148,5 @@
 
     /* Create the contact header */
-    contact->ptr = pj_pool_alloc(pool, PJSIP_MAX_URL_SIZE);
+    contact->ptr = (char*) pj_pool_alloc(pool, PJSIP_MAX_URL_SIZE);
     contact->slen = pj_ansi_snprintf(contact->ptr, PJSIP_MAX_URL_SIZE,
 				     "%.*s%s<%s:%.*s%s%.*s:%d;transport=%s>",
@@ -1170,5 +1175,5 @@
     acc = &pjsua_var.acc[acc_id];
 
-    PJ_ASSERT_RETURN(tp_id >= 0 && tp_id < PJ_ARRAY_SIZE(pjsua_var.tpdata),
+    PJ_ASSERT_RETURN(tp_id >= 0 && tp_id < (int)PJ_ARRAY_SIZE(pjsua_var.tpdata),
 		     PJ_EINVAL);
     
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 1266)
@@ -204,5 +204,5 @@
     pjsua_acc *acc;
     pjsua_call *call;
-    unsigned call_id;
+    int call_id = -1;
     pj_str_t contact;
     pjsip_tx_data *tdata;
@@ -211,5 +211,5 @@
 
     /* Check that account is valid */
-    PJ_ASSERT_RETURN(acc_id>=0 || acc_id<PJ_ARRAY_SIZE(pjsua_var.acc), 
+    PJ_ASSERT_RETURN(acc_id>=0 || acc_id<(int)PJ_ARRAY_SIZE(pjsua_var.acc), 
 		     PJ_EINVAL);
 
@@ -231,10 +231,10 @@
 
     /* Find free call slot. */
-    for (call_id=0; call_id<pjsua_var.ua_cfg.max_calls; ++call_id) {
+    for (call_id=0; call_id<(int)pjsua_var.ua_cfg.max_calls; ++call_id) {
 	if (pjsua_var.calls[call_id].inv == NULL)
 	    break;
     }
 
-    if (call_id == pjsua_var.ua_cfg.max_calls) {
+    if (call_id == (int)pjsua_var.ua_cfg.max_calls) {
 	pjsua_perror(THIS_FILE, "Error making file", PJ_ETOOMANY);
 	PJSUA_UNLOCK();
@@ -508,5 +508,5 @@
 
 	/* Get the replaced call instance */
-	replaced_call = replaced_dlg->mod_data[pjsua_var.mod.id];
+	replaced_call = (pjsua_call*) replaced_dlg->mod_data[pjsua_var.mod.id];
 
 	/* Notify application */
@@ -691,5 +691,5 @@
 
 	/* Get the replaced call instance */
-	replaced_call = replaced_dlg->mod_data[pjsua_var.mod.id];
+	replaced_call = (pjsua_call*) replaced_dlg->mod_data[pjsua_var.mod.id];
 
 	/* Notify application */
@@ -1378,5 +1378,5 @@
 		      dest_dlg->remote.info->tag.slen +
 		      dest_dlg->local.info->tag.slen + 32 
-		      < sizeof(str_dest_buf), PJSIP_EURITOOLONG);
+		      < (long)sizeof(str_dest_buf), PJSIP_EURITOOLONG);
 
     /* Print URI */
@@ -1384,5 +1384,5 @@
     str_dest.slen = 1;
 
-    uri = pjsip_uri_get_uri(dest_dlg->remote.info->uri);
+    uri = (pjsip_uri*) pjsip_uri_get_uri(dest_dlg->remote.info->uri);
     len = pjsip_uri_print(PJSIP_URI_IN_REQ_URI, uri, 
 		          str_dest_buf+1, sizeof(str_dest_buf)-1);
@@ -1510,5 +1510,5 @@
 
     /* Create IM data and attach to the request. */
-    im_data = pj_pool_zalloc(tdata->pool, sizeof(*im_data));
+    im_data = PJ_POOL_ZALLOC_T(tdata->pool, pjsua_im_data);
     im_data->acc_id = call->acc_id;
     im_data->call_id = call_id;
@@ -1935,5 +1935,5 @@
     PJSUA_LOCK();
 
-    call = inv->dlg->mod_data[pjsua_var.mod.id];
+    call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
 
     if (!call) {
@@ -2105,5 +2105,5 @@
     PJSUA_LOCK();
 
-    call = inv->dlg->mod_data[pjsua_var.mod.id];
+    call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
 
     if (status != PJ_SUCCESS) {
@@ -2232,5 +2232,5 @@
     PJSUA_LOCK();
 
-    call = inv->dlg->mod_data[pjsua_var.mod.id];
+    call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
 
     /*
@@ -2315,5 +2315,5 @@
 	pjsua_call *call;
 
-	call = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+	call = (pjsua_call*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
 
 	/* Must be receipt of response message */
@@ -2378,5 +2378,5 @@
 	pj_status_t status;
 
-	call = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+	call = (pjsua_call*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
 
 	/* When subscription is terminated, clear the xfer_sub member of 
@@ -2422,5 +2422,5 @@
 
 	    /* Try to parse the content */
-	    status = pjsip_parse_status_line(body->data, body->len, 
+	    status = pjsip_parse_status_line((char*)body->data, body->len, 
 					     &status_line);
 	    if (status != PJ_SUCCESS) {
@@ -2467,5 +2467,5 @@
 	pjsua_call *call;
 
-	call = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+	call = (pjsua_call*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
 	if (!call)
 	    return;
@@ -2502,5 +2502,5 @@
     pjsip_evsub *sub;
 
-    existing_call = inv->dlg->mod_data[pjsua_var.mod.id];
+    existing_call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
 
     /* Find the Refer-To header */
@@ -2529,5 +2529,6 @@
      * request.
      */
-    ref_by_hdr = pjsip_msg_find_hdr_by_name(rdata->msg_info.msg, &str_ref_by, 
+    ref_by_hdr = (pjsip_hdr*)
+		 pjsip_msg_find_hdr_by_name(rdata->msg_info.msg, &str_ref_by, 
 					    NULL);
 
@@ -2656,5 +2657,6 @@
      */
     if (ref_by_hdr != NULL) {
-	pjsip_hdr *dup = pjsip_hdr_clone(rdata->tp_info.pool, ref_by_hdr);
+	pjsip_hdr *dup = (pjsip_hdr*)
+			 pjsip_hdr_clone(rdata->tp_info.pool, ref_by_hdr);
 	pj_list_push_back(&msg_data.hdr_list, dup);
     }
@@ -2711,5 +2713,5 @@
 					    pjsip_event *e)
 {
-    pjsua_call *call = inv->dlg->mod_data[pjsua_var.mod.id];
+    pjsua_call *call = (pjsua_call*) inv->dlg->mod_data[pjsua_var.mod.id];
 
     PJSUA_LOCK();
@@ -2773,5 +2775,5 @@
 	    pjsua_im_data *im_data;
 
-	    im_data = tsx->mod_data[pjsua_var.mod.id];
+	    im_data = (pjsua_im_data*) tsx->mod_data[pjsua_var.mod.id];
 	    /* im_data can be NULL if this is typing indication */
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 1266)
@@ -165,5 +165,6 @@
     cap_hdr = pjsip_endpt_get_capability(pjsua_var.endpt, PJSIP_H_ALLOW, NULL);
     if (cap_hdr) {
-	pjsip_msg_add_hdr(tdata->msg, pjsip_hdr_clone(tdata->pool, cap_hdr));
+	pjsip_msg_add_hdr(tdata->msg, 
+			  (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, cap_hdr));
     }
 
@@ -171,5 +172,6 @@
     cap_hdr = pjsip_endpt_get_capability(pjsua_var.endpt, PJSIP_H_ACCEPT, NULL);
     if (cap_hdr) {
-	pjsip_msg_add_hdr(tdata->msg, pjsip_hdr_clone(tdata->pool, cap_hdr));
+	pjsip_msg_add_hdr(tdata->msg, 
+			  (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, cap_hdr));
     }
 
@@ -177,5 +179,6 @@
     cap_hdr = pjsip_endpt_get_capability(pjsua_var.endpt, PJSIP_H_SUPPORTED, NULL);
     if (cap_hdr) {
-	pjsip_msg_add_hdr(tdata->msg, pjsip_hdr_clone(tdata->pool, cap_hdr));
+	pjsip_msg_add_hdr(tdata->msg, 
+			  (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, cap_hdr));
     }
 
@@ -183,5 +186,6 @@
     cap_hdr = pjsip_evsub_get_allow_events_hdr(NULL);
     if (cap_hdr) {
-	pjsip_msg_add_hdr(tdata->msg, pjsip_hdr_clone(tdata->pool, cap_hdr));
+	pjsip_msg_add_hdr(tdata->msg, 
+			  (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, cap_hdr));
     }
 
@@ -1456,5 +1460,6 @@
 
     /* Make sure id is in range. */
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0 && id<(int)PJ_ARRAY_SIZE(pjsua_var.tpdata), 
+		     PJ_EINVAL);
 
     /* Make sure that transport exists */
@@ -1524,5 +1529,6 @@
 {
     /* Make sure id is in range. */
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0 && id<(int)PJ_ARRAY_SIZE(pjsua_var.tpdata), 
+		     PJ_EINVAL);
 
     /* Make sure that transport exists */
@@ -1547,5 +1553,6 @@
 
     /* Make sure id is in range. */
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.tpdata), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0 && id<(int)PJ_ARRAY_SIZE(pjsua_var.tpdata), 
+		     PJ_EINVAL);
 
     /* Make sure that transport exists */
@@ -1640,5 +1647,5 @@
 	pjsip_hdr *new_hdr;
 
-	new_hdr = pjsip_hdr_clone(tdata->pool, hdr);
+	new_hdr = (pjsip_hdr*) pjsip_hdr_clone(tdata->pool, hdr);
 	pjsip_msg_add_hdr(tdata->msg, new_hdr);
 
@@ -1672,5 +1679,5 @@
 	pjsip_route_hdr *new_r;
 
-	new_r = pjsip_hdr_clone(tdata->pool, r);
+	new_r = (pjsip_route_hdr*) pjsip_hdr_clone(tdata->pool, r);
 	pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)new_r);
 
@@ -1719,5 +1726,5 @@
 	return;
 
-    pj_assert(tp_id >= 0 && tp_id < PJ_ARRAY_SIZE(pjsua_var.tpdata));
+    pj_assert(tp_id >= 0 && tp_id < (int)PJ_ARRAY_SIZE(pjsua_var.tpdata));
     tpdata = &pjsua_var.tpdata[tp_id];
 
@@ -1749,5 +1756,5 @@
     if (!pool) return -1;
 
-    url = pj_pool_alloc(pool, len+1);
+    url = (char*) pj_pool_alloc(pool, len+1);
     pj_ansi_strcpy(url, c_url);
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_im.c	(revision 1266)
@@ -113,5 +113,6 @@
      * "text/plain".
      */
-    ctype = pjsip_msg_find_hdr(msg, PJSIP_H_CONTENT_TYPE, NULL);
+    ctype = (pjsip_ctype_hdr*)
+	    pjsip_msg_find_hdr(msg, PJSIP_H_CONTENT_TYPE, NULL);
     if (msg->body == NULL || ctype == NULL || 
 	!acceptable_message(&ctype->media)) 
@@ -143,9 +144,10 @@
 
     /* Build remote contact */
-    contact_hdr = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT,
+    contact_hdr = (pjsip_contact_hdr*)
+		  pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT,
 				     NULL);
     if (contact_hdr) {
-	contact.ptr = pj_pool_alloc(rdata->tp_info.pool, 
-				    PJSIP_MAX_URL_SIZE);
+	contact.ptr = (char*) pj_pool_alloc(rdata->tp_info.pool, 
+				    	    PJSIP_MAX_URL_SIZE);
 	contact.slen = pjsip_uri_print(PJSIP_URI_IN_CONTACT_HDR,
 				       contact_hdr->uri, contact.ptr,
@@ -163,5 +165,5 @@
 	
 	/* Save text body */
-	text_body.ptr = rdata->msg_info.msg->body->data;
+	text_body.ptr = (char*) rdata->msg_info.msg->body->data;
 	text_body.slen = rdata->msg_info.msg->body->len;
 
@@ -176,7 +178,7 @@
 	pj_bool_t is_typing;
 
-	status = pjsip_iscomposing_parse( rdata->tp_info.pool, body->data,
-					  body->len, &is_typing, NULL, NULL,
-					  NULL );
+	status = pjsip_iscomposing_parse(rdata->tp_info.pool, (char*)body->data,
+					 body->len, &is_typing, NULL, NULL,
+					 NULL );
 	if (status != PJ_SUCCESS) {
 	    pjsua_perror(THIS_FILE, "Invalid MESSAGE body", status);
@@ -241,6 +243,7 @@
      * not available, then use From header.
      */
-    from.ptr = pj_pool_alloc(rdata->tp_info.pool, PJSIP_MAX_URL_SIZE);
-    contact_hdr = pjsip_msg_find_hdr(rdata->msg_info.msg,
+    from.ptr = (char*) pj_pool_alloc(rdata->tp_info.pool, PJSIP_MAX_URL_SIZE);
+    contact_hdr = (pjsip_contact_hdr*)
+		  pjsip_msg_find_hdr(rdata->msg_info.msg,
 				     PJSIP_H_CONTACT, NULL);
     if (contact_hdr) {
@@ -258,5 +261,5 @@
 
     /* Build the To text. */
-    to.ptr = pj_pool_alloc(rdata->tp_info.pool, PJSIP_MAX_URL_SIZE);
+    to.ptr = (char*) pj_pool_alloc(rdata->tp_info.pool, PJSIP_MAX_URL_SIZE);
     to.slen = pjsip_uri_print( PJSIP_URI_IN_FROMTO_HDR, 
 			       rdata->msg_info.to->uri,
@@ -276,5 +279,5 @@
 static void im_callback(void *token, pjsip_event *e)
 {
-    pjsua_im_data *im_data = token;
+    pjsua_im_data *im_data = (pjsua_im_data*) token;
 
     if (e->type == PJSIP_EVENT_TSX_STATE) {
@@ -353,5 +356,5 @@
 static void typing_callback(void *token, pjsip_event *e)
 {
-    pjsua_im_data *im_data = token;
+    pjsua_im_data *im_data = (pjsua_im_data*) token;
 
     if (e->type == PJSIP_EVENT_TSX_STATE) {
@@ -464,5 +467,5 @@
      * application on the callback
      */
-    im_data = pj_pool_zalloc(tdata->pool, sizeof(*im_data));
+    im_data = PJ_POOL_ZALLOC_T(tdata->pool, pjsua_im_data);
     im_data->acc_id = acc_id;
     im_data->call_id = PJSUA_INVALID_ID;
@@ -571,5 +574,5 @@
 
     /* Create data to reauthenticate */
-    im_data = pj_pool_zalloc(tdata->pool, sizeof(*im_data));
+    im_data = PJ_POOL_ZALLOC_T(tdata->pool, pjsua_im_data);
     im_data->acc_id = acc_id;
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 1266)
@@ -1238,5 +1238,5 @@
 PJ_DEF(pjsua_conf_port_id) pjsua_player_get_conf_port(pjsua_player_id id)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0&&id<(int)PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.player[id].port != NULL, PJ_EINVAL);
 
@@ -1250,5 +1250,5 @@
 					   pjmedia_port **p_port)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0&&id<(int)PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.player[id].port != NULL, PJ_EINVAL);
     PJ_ASSERT_RETURN(p_port != NULL, PJ_EINVAL);
@@ -1265,5 +1265,5 @@
 					  pj_uint32_t samples)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0&&id<(int)PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.player[id].port != NULL, PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.player[id].type == 0, PJ_EINVAL);
@@ -1279,5 +1279,5 @@
 PJ_DEF(pj_status_t) pjsua_player_destroy(pjsua_player_id id)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0&&id<(int)PJ_ARRAY_SIZE(pjsua_var.player), PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.player[id].port != NULL, PJ_EINVAL);
 
@@ -1415,5 +1415,6 @@
 PJ_DEF(pjsua_conf_port_id) pjsua_recorder_get_conf_port(pjsua_recorder_id id)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.recorder), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0 && id<(int)PJ_ARRAY_SIZE(pjsua_var.recorder), 
+		     PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.recorder[id].port != NULL, PJ_EINVAL);
 
@@ -1427,5 +1428,6 @@
 					     pjmedia_port **p_port)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.recorder), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0 && id<(int)PJ_ARRAY_SIZE(pjsua_var.recorder), 
+		     PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.recorder[id].port != NULL, PJ_EINVAL);
     PJ_ASSERT_RETURN(p_port != NULL, PJ_EINVAL);
@@ -1440,5 +1442,6 @@
 PJ_DEF(pj_status_t) pjsua_recorder_destroy(pjsua_recorder_id id)
 {
-    PJ_ASSERT_RETURN(id>=0 && id<PJ_ARRAY_SIZE(pjsua_var.recorder), PJ_EINVAL);
+    PJ_ASSERT_RETURN(id>=0 && id<(int)PJ_ARRAY_SIZE(pjsua_var.recorder), 
+		     PJ_EINVAL);
     PJ_ASSERT_RETURN(pjsua_var.recorder[id].port != NULL, PJ_EINVAL);
 
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_pres.c	(revision 1266)
@@ -38,5 +38,5 @@
 PJ_DEF(pj_bool_t) pjsua_buddy_is_valid(pjsua_buddy_id buddy_id)
 {
-    return buddy_id>=0 && buddy_id<PJ_ARRAY_SIZE(pjsua_var.buddy) &&
+    return buddy_id>=0 && buddy_id<(int)PJ_ARRAY_SIZE(pjsua_var.buddy) &&
 	   pjsua_var.buddy[buddy_id].uri.slen != 0;
 }
@@ -153,5 +153,5 @@
 
     /* Find empty slot */
-    for (index=0; index<PJ_ARRAY_SIZE(pjsua_var.buddy); ++index) {
+    for (index=0; index<(int)PJ_ARRAY_SIZE(pjsua_var.buddy); ++index) {
 	if (pjsua_var.buddy[index].uri.slen == 0)
 	    break;
@@ -424,5 +424,5 @@
     PJSUA_LOCK();
 
-    uapres = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+    uapres = (pjsua_srv_pres*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
     if (uapres) {
 	PJ_LOG(3,(THIS_FILE, "Server subscription to %s is %s",
@@ -517,7 +517,7 @@
 
     /* Attach our data to the subscription: */
-    uapres = pj_pool_alloc(dlg->pool, sizeof(pjsua_srv_pres));
+    uapres = PJ_POOL_ALLOC_T(dlg->pool, pjsua_srv_pres);
     uapres->sub = sub;
-    uapres->remote = pj_pool_alloc(dlg->pool, PJSIP_MAX_URL_SIZE);
+    uapres->remote = (char*) pj_pool_alloc(dlg->pool, PJSIP_MAX_URL_SIZE);
     status = pjsip_uri_print(PJSIP_URI_IN_REQ_URI, dlg->remote.info->uri,
 			     uapres->remote, PJSIP_MAX_URL_SIZE);
@@ -586,5 +586,5 @@
 static void publish_cb(struct pjsip_publishc_cbparam *param)
 {
-    pjsua_acc *acc = param->token;
+    pjsua_acc *acc = (pjsua_acc*) param->token;
 
     if (param->code/100 != 2 || param->status != PJ_SUCCESS) {
@@ -856,5 +856,5 @@
     PJSUA_LOCK();
 
-    buddy = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+    buddy = (pjsua_buddy*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
     if (buddy) {
 	PJ_LOG(3,(THIS_FILE, 
@@ -889,5 +889,5 @@
     PJSUA_LOCK();
 
-    buddy = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+    buddy = (pjsua_buddy*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
     if (!buddy) {
 	PJSUA_UNLOCK();
@@ -915,5 +915,6 @@
 
     /* Find contact header. */
-    contact_hdr = pjsip_msg_find_hdr(event->body.rx_msg.rdata->msg_info.msg,
+    contact_hdr = (pjsip_contact_hdr*)
+		  pjsip_msg_find_hdr(event->body.rx_msg.rdata->msg_info.msg,
 				     PJSIP_H_CONTACT, NULL);
     if (!contact_hdr) {
@@ -922,5 +923,6 @@
     }
 
-    buddy->contact.ptr = pj_pool_alloc(pjsua_var.pool, PJSIP_MAX_URL_SIZE);
+    buddy->contact.ptr = (char*)
+			 pj_pool_alloc(pjsua_var.pool, PJSIP_MAX_URL_SIZE);
     buddy->contact.slen = pjsip_uri_print( PJSIP_URI_IN_CONTACT_HDR,
 					   contact_hdr->uri,
@@ -946,5 +948,5 @@
     PJSUA_LOCK();
 
-    buddy = pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
+    buddy = (pjsua_buddy*) pjsip_evsub_get_mod_data(sub, pjsua_var.mod.id);
     if (buddy) {
 	/* Update our info. */
Index: pjproject/trunk/pjsip/src/test-pjsip/dns_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/dns_test.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/test-pjsip/dns_test.c	(revision 1266)
@@ -36,5 +36,5 @@
 	       const struct pjsip_server_addresses *addr)
 {
-    struct result *result = token;
+    struct result *result = (struct result*) token;
 
     result->status = status;
Index: pjproject/trunk/pjsip/src/test-pjsip/msg_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/test-pjsip/msg_test.c	(revision 1266)
@@ -187,6 +187,6 @@
 
     /* Create buffer for comparison. */
-    str1.ptr = pj_pool_alloc(pool, BUFLEN);
-    str2.ptr = pj_pool_alloc(pool, BUFLEN);
+    str1.ptr = (char*)pj_pool_alloc(pool, BUFLEN);
+    str2.ptr = (char*)pj_pool_alloc(pool, BUFLEN);
 
     /* Compare message type. */
@@ -661,9 +661,9 @@
 
     // Body
-    body = pj_pool_zalloc(pool, sizeof(*body));
+    body = PJ_POOL_ZALLOC_T(pool, pjsip_msg_body);
     msg->body = body;
     body->content_type.type = pj_str("application");
     body->content_type.subtype = pj_str("sdp");
-    body->data = 
+    body->data = (void*)
 	"v=0\r\n"
 	"o=alice 53655765 2353687637 IN IP4 pc33.atlanta.com\r\n"
@@ -673,5 +673,5 @@
 	"m=audio 3456 RTP/AVP 0 1 3 99\r\n"
 	"a=rtpmap:0 PCMU/8000\r\n";
-    body->len = pj_native_strlen(body->data);
+    body->len = pj_native_strlen((const char*) body->data);
     body->print_body = &pjsip_print_text_body;
 
@@ -716,5 +716,5 @@
 
     for (loop=0; loop<LOOP; ++loop) {
-	for (i=0; i<PJ_ARRAY_SIZE(test_array); ++i) {
+	for (i=0; i<(int)PJ_ARRAY_SIZE(test_array); ++i) {
 	    pool = pjsip_endpt_create_pool(endpt, NULL, POOL_SIZE, POOL_SIZE);
 	    status = test_entry( pool, &test_array[i] );
@@ -1454,5 +1454,7 @@
 	hname = pj_str(test->hname);
 	len = strlen(test->hcontent);
-	parsed_hdr1 = pjsip_parse_hdr(pool, &hname, test->hcontent, len, &parsed_len);
+	parsed_hdr1 = (pjsip_hdr*) pjsip_parse_hdr(pool, &hname, 
+						   test->hcontent, len, 
+						   &parsed_len);
 	if (parsed_hdr1 == NULL) {
 	    if (test->flags & HDR_FLAG_PARSE_FAIL) {
@@ -1476,5 +1478,5 @@
 	    hname = pj_str(test->hshort_name);
 	    len = strlen(test->hcontent);
-	    parsed_hdr2 = pjsip_parse_hdr(pool, &hname, test->hcontent, len, &parsed_len);
+	    parsed_hdr2 = (pjsip_hdr*) pjsip_parse_hdr(pool, &hname, test->hcontent, len, &parsed_len);
 	    if (parsed_hdr2 == NULL) {
 		PJ_LOG(3,(THIS_FILE, "    error parsing header %s: %s", test->hshort_name, test->hcontent));
@@ -1490,5 +1492,5 @@
 
 	/* Print the original header */
-	input = pj_pool_alloc(pool, 1024);
+	input = (char*) pj_pool_alloc(pool, 1024);
 	len = pj_ansi_snprintf(input, 1024, "%s: %s", test->hname, test->hcontent);
 	if (len < 1 || len >= 1024)
@@ -1496,5 +1498,5 @@
 
 	/* Print the parsed header*/
-	output = pj_pool_alloc(pool, 1024);
+	output = (char*) pj_pool_alloc(pool, 1024);
 	len = pjsip_hdr_print_on(parsed_hdr1, output, 1024);
 	if (len < 1 || len >= 1024) {
Index: pjproject/trunk/pjsip/src/test-pjsip/transport_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/transport_test.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/test-pjsip/transport_test.c	(revision 1266)
@@ -561,5 +561,5 @@
 
 	/* Generate Call-ID for each thread. */
-	rt_test_data[i].call_id.ptr = pj_pool_alloc(pool, rt_call_id.slen+1);
+	rt_test_data[i].call_id.ptr = (char*) pj_pool_alloc(pool, rt_call_id.slen+1);
 	pj_strcpy(&rt_test_data[i].call_id, &rt_call_id);
 	buf[0] = '0' + i;
Index: pjproject/trunk/pjsip/src/test-pjsip/tsx_bench.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/tsx_bench.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/test-pjsip/tsx_bench.c	(revision 1266)
@@ -54,5 +54,5 @@
 
     /* Create transaction array */
-    tsx = pj_pool_zalloc(request->pool, working_set * sizeof(pj_pool_t*));
+    tsx = (pjsip_transaction**) pj_pool_zalloc(request->pool, working_set * sizeof(pj_pool_t*));
 
     pj_bzero(&mod_tsx_user, sizeof(mod_tsx_user));
@@ -131,8 +131,8 @@
     rdata.tp_info.pool = request->pool;
     rdata.msg_info.msg = request->msg;
-    rdata.msg_info.from = pjsip_msg_find_hdr(request->msg, PJSIP_H_FROM, NULL);
-    rdata.msg_info.to = pjsip_msg_find_hdr(request->msg, PJSIP_H_TO, NULL);
-    rdata.msg_info.cseq = pjsip_msg_find_hdr(request->msg, PJSIP_H_CSEQ, NULL);
-    rdata.msg_info.cid = pjsip_msg_find_hdr(request->msg, PJSIP_H_FROM, NULL);
+    rdata.msg_info.from = (pjsip_from_hdr*) pjsip_msg_find_hdr(request->msg, PJSIP_H_FROM, NULL);
+    rdata.msg_info.to = (pjsip_to_hdr*) pjsip_msg_find_hdr(request->msg, PJSIP_H_TO, NULL);
+    rdata.msg_info.cseq = (pjsip_cseq_hdr*) pjsip_msg_find_hdr(request->msg, PJSIP_H_CSEQ, NULL);
+    rdata.msg_info.cid = (pjsip_cid_hdr*) pjsip_msg_find_hdr(request->msg, PJSIP_H_FROM, NULL);
     rdata.msg_info.via = via;
     
@@ -148,5 +148,5 @@
 
     /* Create transaction array */
-    tsx = pj_pool_zalloc(request->pool, working_set * sizeof(pj_pool_t*));
+    tsx = (pjsip_transaction**) pj_pool_zalloc(request->pool, working_set * sizeof(pj_pool_t*));
 
     pj_bzero(&mod_tsx_user, sizeof(mod_tsx_user));
Index: pjproject/trunk/pjsip/src/test-pjsip/tsx_uac_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/tsx_uac_test.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/test-pjsip/tsx_uac_test.c	(revision 1266)
@@ -365,5 +365,5 @@
 		PJ_LOG(3,(THIS_FILE, 
 			  "    error: prev state is %s instead of %s",
-			  pjsip_tsx_state_str(e->body.tsx_state.prev_state),
+			  pjsip_tsx_state_str((pjsip_tsx_state_e)e->body.tsx_state.prev_state),
 			  pjsip_tsx_state_str(PJSIP_TSX_STATE_PROCEEDING)));
 		test_complete = -739;
@@ -548,5 +548,5 @@
 				    struct pj_timer_entry *entry)
 {
-    struct response *r = entry->user_data;
+    struct response *r = (struct response*) entry->user_data;
     pjsip_transport *tp = r->res_addr.transport;
 
@@ -760,5 +760,5 @@
 
 	/* Schedule sending final response in couple of of secs. */
-	r = pj_pool_alloc(tdata->pool, sizeof(*r));
+	r = PJ_POOL_ALLOC_T(tdata->pool, struct response);
 	r->res_addr = res_addr;
 	r->tdata = tdata;
@@ -881,5 +881,5 @@
 
 	    /* Schedule sending final response in couple of of secs. */
-	    r = pj_pool_alloc(tdata->pool, sizeof(*r));
+	    r = PJ_POOL_ALLOC_T(tdata->pool, struct response);
 	    r->res_addr = res_addr;
 	    r->tdata = tdata;
@@ -969,5 +969,5 @@
 
     /* Set the branch param for test 1. */
-    via = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
+    via = (pjsip_via_hdr*) pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
     via->branch_param = pj_str(branch_param);
 
@@ -1098,5 +1098,5 @@
     enabled = msg_logger_set_enabled(0);
 
-    for (i=0; i<PJ_ARRAY_SIZE(sub_test); ++i) {
+    for (i=0; i<(int)PJ_ARRAY_SIZE(sub_test); ++i) {
 
 	PJ_LOG(3,(THIS_FILE, 
@@ -1232,5 +1232,5 @@
 
 
-    for (i=0; i<PJ_ARRAY_SIZE(delay); ++i) {
+    for (i=0; i<(int)PJ_ARRAY_SIZE(delay); ++i) {
 
 	PJ_LOG(3,(THIS_FILE, 
@@ -1303,5 +1303,5 @@
 
     /* Do the test. */
-    for (i=0; i<PJ_ARRAY_SIZE(delay); ++i) {
+    for (i=0; i<(int)PJ_ARRAY_SIZE(delay); ++i) {
 	
 	if (test_param->type == PJSIP_TRANSPORT_LOOP_DGRAM) {
@@ -1344,5 +1344,5 @@
 
     /* Get transport flag */
-    tp_flag = pjsip_transport_get_flag_from_type(test_param->type);
+    tp_flag = pjsip_transport_get_flag_from_type((pjsip_transport_type_e)test_param->type);
 
     pj_ansi_sprintf(TARGET_URI, "sip:bob@127.0.0.1:%d;transport=%s", 
Index: pjproject/trunk/pjsip/src/test-pjsip/tsx_uas_test.c
===================================================================
--- pjproject/trunk/pjsip/src/test-pjsip/tsx_uas_test.c	(revision 1265)
+++ pjproject/trunk/pjsip/src/test-pjsip/tsx_uas_test.c	(revision 1266)
@@ -209,5 +209,5 @@
 {
     pjsip_transaction *tsx;
-    struct response *r = entry->user_data;
+    struct response *r = (struct response*) entry->user_data;
     pj_status_t status;
 
@@ -277,5 +277,5 @@
     }
 
-    r = pj_pool_alloc(tdata->pool, sizeof(*r));
+    r = PJ_POOL_ALLOC_T(tdata->pool, struct response);
     pj_strdup(tdata->pool, &r->tsx_key, tsx_key);
     r->tdata = tdata;
@@ -285,5 +285,5 @@
     pj_time_val_normalize(&delay);
 
-    t = pj_pool_zalloc(tdata->pool, sizeof(*t));
+    t = PJ_POOL_ZALLOC_T(tdata->pool, pj_timer_entry);
     t->user_data = r;
     t->cb = &send_response_timer;
@@ -1097,5 +1097,5 @@
 		uri->transport_param = pj_str("loop-dgram");
 
-		via = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
+		via = (pjsip_via_hdr*) pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
 		via->branch_param = pj_str(TEST9_BRANCH_ID);
 
@@ -1198,5 +1198,5 @@
 
     /* Set the branch param for test 1. */
-    via = pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
+    via = (pjsip_via_hdr*) pjsip_msg_find_hdr(tdata->msg, PJSIP_H_VIA, NULL);
     via->branch_param = pj_str(branch_param);
 
@@ -1472,5 +1472,5 @@
     int i, status;
 
-    for (i=0; i<PJ_ARRAY_SIZE(tests); ++i) {
+    for (i=0; i<(int)PJ_ARRAY_SIZE(tests); ++i) {
 	pj_time_val fail_time, end_test, now;
 
@@ -1533,5 +1533,5 @@
 
     test_param = param;
-    tp_flag = pjsip_transport_get_flag_from_type(param->type);
+    tp_flag = pjsip_transport_get_flag_from_type((pjsip_transport_type_e)param->type);
 
     pj_ansi_sprintf(TARGET_URI, "sip:bob@127.0.0.1:%d;transport=%s", 
